<template>
  <div
    v-if="!gameProviderThemeProperty.IsHidden"
    class="flex flex-col w-full pt-10"
  >
    <div class="flex items-center justify-between mb-4">
      <span class="text-2xl font-bold --text2">{{
        `${
          gameProviderThemeProperty.Text !== "Game Providers"
            ? gameProviderThemeProperty.Text
            : $t("game_providers")
        }`
      }}</span>
      <nuxt-link class="text-base fc-primary" to="/games"
        >{{ $t("see_all")
        }}<font-awesome-icon class="ml-3" icon="arrow-right-long"
      /></nuxt-link>
    </div>
    <div class="grid items-start grid-cols-6 grid-rows-1 gap-x-4">
      <div
        v-for="item in gameProviders"
        :key="item"
        class="flex flex-col gap-2"
      >
        <nuxt-link
          :class="{ 'grayscale-[1] pointer-events-none': item.IsMaintain }"
          :to="authenticated ? `/games/${item.ProviderName}` : '/login'"
          class="h-[6.25rem] block rounded-lg bg-background1 text-center"
        >
          <div
            v-if="item.IsMaintain"
            class="absolute w-12 h-12 top-[20px] left-[35%] z-[2]"
          >
            <img
              :src="
                getAssetImage('assets/theme/common/icon/icon_maintainance.png')
              "
              alt=""
            />
          </div>
          <div class="inline-block h-full">
            <img
              v-lazy="
                handle(
                  `provider_icon/games/${item.ProviderName.replace(
                    ' ',
                    '_'
                  ).toLowerCase()}/star.png`
                )
              "
              class="w-auto h-full rounded-lg"
            />
          </div>
        </nuxt-link>
        <span class="self-center">{{ item.GameProviderDisplayName }}</span>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { computed, defineComponent } from "vue";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import themePropertiesHelper from "@/utils/themePropertyHelper";
import { ISeamlessProviderList } from "@/models/bsiGameList";
import commonHelper from "@/utils/commonHelper";
import { store } from "~~/store";

export default defineComponent({
  setup() {
    const { state } = store;
    const authenticated = computed(() => state.auth);
    const themeProperties = state.companyThemePropertiesFromApi.ThemeProperties;
    const gameProviderThemeProperty =
      themePropertiesHelper.getSingleThemeProperty(
        themeProperties,
        "index_blog_5"
      );
    const gameProviders = computed(
      (): Array<ISeamlessProviderList> =>
        _.slice(state.gameTabProviderList.SeamlessProviderList, 0, 6).map(
          (item) => {
            if (Object.keys(state.gameProviders).length <= 0) return item;
            const provider = state.gameProviders?.Games.find(
              (gameProvider) =>
                gameProvider.GameProviderName === item.ProviderName
            );
            const IsMaintain = provider ? provider.IsMaintain : false;
            return {
              ...item,
              GameProviderDisplayName: provider.GameProviderDisplayName,
              IsMaintain,
            };
          }
        )
    );
    const { getAssetImage } = commonHelper;
    const handle = (path: string) => commonHelper.handleImportCommonImage(path);
    return {
      handle,
      gameProviders,
      authenticated,
      gameProviderThemeProperty,
      getAssetImage,
    };
  },
});
</script>

<style scoped></style>
